from DateTime import DateTime
portal = context.getPortalObject()

instance_tree = context

if instance_tree.getSlapState() == "destroy_requested":
  return

if portal.portal_catalog.getResultValue(
  portal_type='Upgrade Decision',
  aggregate__uid=instance_tree.getUid(),
  simulation_state=['started', 'stopped', 'planned', 'confirmed']
) is not None:
  # There is already a upgrade decision, do nothing
  return

"""
if decision_in_progress is not None:
  if 1:
    raise NotImplementedError('reviewRegistration')
  decision_in_progress.reviewRegistration(
    software_release_url=newer_release.getUrlString())
  if decision_in_progress.getSimulationState() != "cancelled":
    return
"""

# Check if UpgradeDecision_approveRegistration is running
# XXX we should instead look at the current upgrade decision state
tag = "%s_requestUpgradeDecisionCreation_inProgress" % instance_tree.getUid()
if portal.portal_activities.countMessageWithTag(tag) > 0:
  # previous run not finished, skip
  return

software_product, software_release, software_type = instance_tree.InstanceTree_getSoftwareProduct()
if software_product is None:
  # No way to upgrade, if we can find which Software Product to upgrade
  return

compute_node = None
root_instance_list = [
  q for q in instance_tree.getSuccessorValueList(portal_type=["Software Instance", "Slave Instance"])
  if q.getSlapState() != 'destroy_requested']
if len(root_instance_list) != 0:
  root_instance = root_instance_list[0]
  if root_instance.getPortalType() == 'Slave Instance':
    # XXX do not upgrade Slave Instance for now
    # should check Instance Node or allocation on same tree
    return
  partition = root_instance.getAggregateValue()
  if partition is not None:
    compute_node = partition.getParentValue()

person = context.getDestinationSectionValue()
if person is None:
  return

# Search if the product with the same type
# XXX search only for the main node
allocation_cell_list = software_product.getFollowUpValue().Project_getSoftwareProductPredicateList(
  software_product=software_product,
  software_product_type=software_type,
  #software_product_release=software_release,
  destination_value=person,
  node_value=compute_node,
  predicate_portal_type='Allocation Supply Cell'
)

# Only upgrade if there is no doubt (ie, only 1 url is allowed)
if len(allocation_cell_list) == 1:
  if (allocation_cell_list[0].getSoftwareReleaseValue().getUrlString() != instance_tree.getUrlString()):
    # XXX Upgrade

    if compute_node is not None:
      assert compute_node.getRelativeUrl() in allocation_cell_list[0].getParentValue().getParentValue().getAggregateList()

    decision_title = 'A new upgrade is available for %s' % instance_tree.getTitle()
    upgrade_decision = portal.upgrade_decision_module.newContent(
      portal_type='Upgrade Decision',
      title=decision_title,
      destination_section_value=person,
      destination_decision_value=person,
      destination_project_value=instance_tree.getFollowUpValue(),
      resource_value=software_product,
      variation_category_list=allocation_cell_list[0].getVariationCategoryList(),
      aggregate_value=instance_tree,
    )

    upgrade_decision.approveRegistration()

    return upgrade_decision
